#include "Canvas.hpp"

void Canvas::init(int size)
{
  backGround.init(size);
  tree.init(size);
  target = LoadRenderTexture(size, size);
}

void Canvas::newGen()
{
  BeginTextureMode(target);
  ClearBackground(WHITE);

  backGround.newGen();
  tree.newGen();

  EndTextureMode();
}

void Canvas::draw(Rectangle dest, float rotation)
{
  Rectangle source = {0, 0, (float)target.texture.width, (float)-target.texture.height};
  Vector2 origin = {0.0f, 0.0f};
  rotation = 360 - rotation;
  DrawTexturePro(target.texture, source, dest, origin, rotation, WHITE);
}

void Canvas::deinit()
{
  UnloadRenderTexture(target);
}