#include <vector>
#include "Canvas.hpp"

class App
{

public:
  App() = default;
  ~App() = default;
  void init(int screenWidth, int screenHeight);
  void update();
  void draw();
  void deinit();

private:
  int pos = 0;
  int screenWidth, screenHeight;
  std::vector<Canvas> canvases;
  Vector2 center;
  float rotation = 0.0f;
  Rectangle destB;
  Rectangle destA;
};
